C*RLD_VLT -- Get Colorbar/limits for Chromatics into generic format
C+
        Options /Extend_Source
        Subroutine RLD_VLT (Ctable)

        Implicit        None
        Byte            Ctable (3, 0:255)

*************************************************************************
*                                                                       *
*   Prompt a user to select a colorbar with low and high limits.        *
*   This is necessary because the Chromatics can not return what        *
*   colorbar is currently being used.                                   *
*                                                                       *
*   Originally written by Gregg Parmentier                              *
*   Modified for use with the GIF/XWD formats by Rick Dyson  1-APR-1991 *
*                                                                       *
*   Routines called: RLD_LIMS - Adjusts color table according to RLD_VLT*
*                    ReadColorbar - Read the colorbar chosen            *
*                    System Services/Run-Time Libraries                 *
*                                                                       *
*************************************************************************
C--     end mark for DOCUMENT program

        Include '($SSDEF)'

        Common / BAR /  BAR, TEXT, LOW, HIGH, BARFIL

        Integer*2       BAR (3, 0:255), TEXT, Minimum, Maximum, I, J, K, LOW, HIGH, TEMP
        Character*3     CMND
        Character*20    BARFIL
        Character*80    LINE
        Logical*1       FIRST / .True. /
        Integer         Lib$Locc, LEN, LEN1
        External        Lib$Locc
        Byte            BYTE

        Equivalence     (BYTE, TEMP)

1       Write (*, 10) '/Enter VLT limits - Low, High, ColorBar [0-255]'
        Read (*, 10, End = 666) LINE

        LEN = Lib$Locc ('?', LINE)
        If (LEN .ne. 0) Then
            I = 0
            Write (6, 10) ' Currently Available ColorBarDir: (do NOT use the extension!)'
            Call Lib$Spawn ( 'Directory ColorBarDir:*.DAT /Brief /NoTrailer')
            Write (6, 10) ' '
            GoTo 1
        EndIf

* --- read limits ---
        Read (LINE, *, Err = 666, End = 666) Minimum, Maximum

* --- color bar name, NT/T ---
        LEN = Lib$Locc (',', LINE)
        LINE = LINE (LEN + 1:80)
        LEN = Lib$Locc (',', LINE)
        If (LEN .eq. 0) Then
            BARFIL = ' '
            CMND   = ' '
        Else
            LINE = LINE (LEN + 1:80)
            LEN = Lib$Locc (',', LINE)
            If (LEN .eq. 0) Then
                LEN   = Lib$Locc (' ', LINE)
                If (LEN .eq. 1) Then
                    BARFIL = ' '
                Else
                    BARFIL = LINE (1:LEN - 1)
                EndIf
                CMND = ' '
            Else
                If (LEN .le. 1) Then
                    BARFIL = ' '
                Else
                    BARFIL = LINE (1:LEN - 1)
                EndIf
                LEN1 = Lib$Locc (' ', LINE)
                If (LEN1 .eq. 1) Then
                    CMND = ' '
                Else
                    If (LEN1 .eq. LEN + 1) Then
                        CMND = ' '
                    Else
                        CMND = LINE (LEN + 1:LEN1 - 1)
                        Call Str$Upcase (CMND, CMND)
                        If (CMND (1:2) .eq. 'NT') TEXT = 1
                        If (CMND (1:1) .eq. 'T' ) TEXT = 0
                    EndIf
                EndIf
            EndIf
        EndIf

        If ((FIRST) .and. (BARFIL (1:1) .eq. ' ')) Then
            BARFIL = 'ISEE'
        EndIf
        If (FIRST) FIRST = .FALSE.
        If (BARFIL (1:1) .ne. ' ') Then
            Call ReadColorBar ()
            BARFIL = '          '
        EndIf

        Call RLD_LIMS (Minimum, Maximum, Ctable)

666     Return

10      Format (A)
        End
C
C*RLD_LIMS -- Re-compute colortable from low and high limits
C+
        Options /Extend_Source
	Subroutine RLD_LIMS (Minimum, Maximum, Ctable)

        Implicit        None
        Integer*2       Minimum, Maximum
        Byte            Ctable (3, 0:255)

*************************************************************************
*                                                                       *
*   Compute the new colortable from the user's choice of low and        *
*   high limits.                                                        *
*                                                                       *
*   Originally written by Gregg Parmentier                              *
*   Modified for use with the GIF/XWD format by Rick Dyson  1-APR-1991  *
*                                                                       *
*************************************************************************
C--     end mark for DOCUMENT program

        Common / BAR /  BAR, TEXT, LOW, HIGH, BarFile

        Byte            BYTE
        Character       Answer
        Character*20    BarFile
        Integer*2       I, J, Lower_Limit, Upper_Limit, TEXT, TEMP
        Integer*2       BAR (3, 0:255), ColorBar (3, 0:255), PLACE, LOW, HIGH
        Real            FJ

        Equivalence     (TEMP, BYTE)

        If (Minimum .eq. Maximum) Return

* --- Minimum < Maximum = normal color bar
        Lower_Limit = Min (Minimum, 255)
        Upper_Limit = Max (Maximum, 0)

* --- 0 to lower limit - 1 ---
        If (Lower_Limit .gt. 0) Then
            Do J = 0, Lower_Limit - 1
                ColorBar (1, J) = 0
                ColorBar (2, J) = 0
                ColorBar (3, J) = 0
            EndDo
        EndIf

* --- for Minimum to Maximum limits ---
        Do J = Lower_Limit, Upper_Limit
            FJ = Float (J)
            PLACE = IFix (0.5 + 255.0 * ((FJ - Lower_Limit) / (Float (Upper_Limit) - Float (Lower_Limit))))
            ColorBar (1, J) = BAR (1, PLACE)
            ColorBar (2, J) = BAR (2, PLACE)
            ColorBar (3, J) = BAR (3, PLACE)
        EndDo

* --- upper limit + 1 to 255 ---
      If (Upper_Limit .lt. 255) Then
        Do J = Upper_Limit + 1, 255
            ColorBar (1, J) = BAR (1, 255) 
            ColorBar (2, J) = BAR (2, 255) 
            ColorBar (3, J) = BAR (3, 255) 
        EndDo
      EndIf

* --- set other colors ---
        Write (6, '(A)') '$Alter the defaults for the foreground & background colors? (Y/N) [Def: N] ==> '
        Read (6, '(A)') Answer
        Call Str$Upcase (Answer, Answer)
        If (Answer .eq. 'Y') Then
            Write (6, 10) ' Enter the BACKGROUND color (R,G,B; 0-255)', ' XXX XXX XXX'
            Read (5, *) ColorBar (1, 0), ColorBar (2, 0), ColorBar (3, 0)
            Write (6, 10) ' Enter the FOREGROUND (or LABELS) color (R,G,B; 0-255)', ' XXX XXX XXX'
            Read (5, *) ColorBar (1, 255), ColorBar (2, 255), ColorBar (3, 255)
        EndIf

* --- Load the newly created colorbar into the output color table
        Do I = 1, 3
            Do J = 0, 255
                TEMP = ColorBar (I, J)
                Ctable (I, J) = BYTE
            EndDo
        EndDo

        Return

10      Format (/A/A)
        End

C
C*ReadColorBar -- Read colorbar/limits from disk file
C+
        Options /Extend_Source
        Subroutine ReadColorBar ()

*************************************************************************
*                                                                       *
* --- ColorTable = unmodified color bar                                 *
* --- ColorBarName = name of color bar                                  *
* --- ColorBarDir = logical name pointing to director location          *
*                                                                       *
*************************************************************************
C--     end mark for DOCUMENT program

        Integer*2       ColorTable (3, 0:255), Text, I, J, Low, Hi
        Character*20    ColorBarName
        Character*50    ColorBarDir
        Integer         Lib$Locc, Len
        External        Lib$Locc

        Common / BAR / ColorTable, Text, Low, Hi, ColorBarName

!        Data ColorBarDir / 'Disk$SAI:[Graphics.CBars]' /
        Data ColorBarDir / 'ColorBarDir:' /

* --- set color bar name ---
        If (ColorBarName (1:1) .ne. ' ') Then
            Len = Lib$Locc (' ', ColorBarName)
            If (Len .eq. 0) Then
!                ColorBarDir = ColorBarDir (1:25) // ColorBarName // '.DAT'
                ColorBarDir = ColorBarDir (1:12) // ColorBarName // '.DAT'
            Else
!                ColorBarDir = ColorBarDir (1:25) // ColorBarName (1:Len - 1) // '.DAT'
                ColorBarDir = ColorBarDir (1:12) // ColorBarName (1:Len - 1) // '.DAT'
            EndIf
        EndIf

* --- open and read color bar ---
        Open (Unit = 2, Err = 100, ReadOnly, Type = 'OLD', Name = ColorBarDir, CarriageControl = 'LIST')
        Read (2, 10, Err = 200) ((ColorTable (I, J), I = 1, 3), J = 0, 255)
        Close (Unit = 2)

        Return

* --- color bar file not found ---
100     Type*, 'Illegal color-bar filename - ' // ColorBarName

        Return

* --- read error on color bar ---
200     Type*, 'Read error on color bar - ' // ColorBarName
        Close (Unit = 2)

        Return

10      Format (3Z2)
        End
