	PROGRAM CRDPIX
!
!  uses CURRENT_IMAGE to prompt user for image file identification,
!  sets up the image file for coordinate calculations, then for input
!  geographic or GEI coordinates, returns pixel location in the file,
!  view coordinates, and luminosity
!
!
        COMMON /IMAGE/  IMFILE,FCTDWN,FCTACR,NPHOT,CENTRMLC,PIXOFF
        COMMON /IMCOORD/IMXMIN,IMXMAX,IMYMAX,STEP,PIXWD,PIXHT,
     &                  SP,ALTF,NSPIN,TSPIN,UTNC1,SOLMSEC1,MDIREC
!
	INTEGER*2	CCOUNT,UCOUNT,PMLC,INDEX,ITYPE,NPHOT,CENTRMLC,
     &			PIXOFF,MDIREC
	INTEGER*4	NSPIN,TSPIN,UTNC1,SOLMSEC1
	REAL*4		NLAT,ELONG,XGEI,YGEI,ZGEI,ALT,XS,YS,INTNS,SP,ALTF,
     &			FCTDWN,FCTACR,IMXMIN,IMXMAX,IMYMAX,STEP,PIXWD,PIXHT
	LOGICAL*1	DSP,VIS
	CHARACTER*128	IMFILE
!
!---get image file and set up for coordinate calculations and pixel
!			value retrieval
	DSP = .FALSE.				!image is not to be displayed
	CALL CURRENT_IMAGE(DSP)			!gets file ID
	CALL IMAGEIN(IMFILE)			!sets up for pixel retrieval
	CALL SETCRD				!sets up for coordinates
!
!---get input coordinates
  9	WRITE(6,'(/,A,/,A)')			!get input type
     &	  ' Enter 1 for geographic',
     &	  '$      2 for GEI coordinate input  >'
	READ(5,'(I1)',END=99) ITYPE
	IF (ITYPE.EQ.1) THEN
	  WRITE(6,'(A,A,/,A)')
     &	    '$Enter N Lat, E Long in ',		!geographic input
     &	    'degrees, altitude in km.',
     &	    ' NNN.N EEE.E KKKK.K'
	  READ(5,'(F5.1,F6.1,F7.1)')
     &		NLAT,ELONG,ALT
	  CALL GEO2VW(NLAT,ELONG,ALT,		!convert to view coordinates
     &		XS,YS,VIS)
	ELSE
	  WRITE(6,'(A,A,/,A)')
     &		'$Enter GEI position in ',	!GEI coordinate input
     &		'kilometers',
     &		' XXXXXX.X YYYYYY.Y ZZZZZZ.Z'
	  READ(5,'(3(F8.1,X))') XGEI,YGEI,ZGEI
	  CALL GEI2VW(XGEI,YGEI,ZGEI,		!convert to view coordinates
     &		XS,YS,VIS)
	ENDIF
	IF ( .NOT.VIS.OR.			!is it visible and in range?
     &	      XS.LT.IMXMIN.OR.XS.GT.IMXMAX.OR.
     &	      YS.GT.IMYMAX.OR.
     &	      YS.LT.IMYMAX-150.	) THEN
	  WRITE(6,'(A)')			!message if not
     &		' That point is not visible.'
	ELSE
	  CALL PXLOC(XS,YS,PMLC,INDEX)		!if visible, get pixel location
	  CALL COUNTS(PMLC,INDEX,
     &			CCOUNT,UCOUNT,INTNS)	!get counts and intensity
	  WRITE(6,'(A,2F5.1,3(A,I4),A,F6.1,A)')	!report results
     &	    ' VwX,Y:',XS,YS,', MirLoc:',PMLC,
     &	    ', Pix#:',INDEX,', UncmpCnt:',
     &	    UCOUNT,', Luminosity:',INTNS,' kr'
	ENDIF
	GO TO 9					!go back for more input
!
 99	STOP
	END
