#
#       MMS Description file for the example DESAI programs from the NSSDC set
#
#       Rick Dyson  29-OCT-1992
#       For VAX/VMS
#
#       Modified:    4-JUN-1993 RLD

PROGRAMS = pixcrd.exe crdpix.exe map.exe imdsp.exe mafcrd.exe checkmaf.exe

SOURCES = DElib.for DEview.for current_image.for imagein.for \
          display.for plot.for setcrd.for testplot.for mag.for \
	  coast.for colorbars.for engif.for

OBJECTS = DElib.obj,DEview.obj,current_image.obj,imagein.obj,display.obj,\
plot.obj,setcrd.obj,testplot.obj,mag.obj

EXTRAS = coast.obj,colorbars.obj,engif.obj

# Compiler flags.

.ifdef DEBUG
FFLAGS = $(FFLAGS) /Extend_Source /NoOptimize /Debug
LINKFLAGS = $(LINKFLAGS) /Debug
.else
FFLAGS = $(FFLAGS) /Extend_Source /Optimize /NoDebug
LINKFLAGS = $(LINKFLAGS) /NoDebug
.endif


# Standard targets.

all :   $(PROGRAMS)
        @ Continue

pixcrd.exe :    pixcrd.obj $(OBJECTS) $(EXTRAS)
        - $(LINK) $(LINKFLAGS) pixcrd.obj,$(OBJECTS),$(EXTRAS)

crdpix.exe :    crdpix.obj $(OBJECTS) $(EXTRAS)
        - $(LINK) $(LINKFLAGS) crdpix.obj,$(OBJECTS),$(EXTRAS)

map.exe :       map.obj $(OBJECTS) $(EXTRAS)
        - $(LINK) $(LINKFLAGS) map.obj,$(OBJECTS),$(EXTRAS)

imdsp.exe :     imdsp.obj $(OBJECTS) $(EXTRAS)
        - $(LINK) $(LINKFLAGS) imdsp.obj,$(OBJECTS),$(EXTRAS)

mafcrd.exe :    mafcrd.obj $(OBJECTS) $(EXTRAS)
        - $(LINK) $(LINKFLAGS) mafcrd.obj,$(OBJECTS),$(EXTRAS)

checkmaf.exe :  checkmaf.for
	- $(FORT) $(FFLAGS) /Warnings = NoUsage checkmaf.for
        - $(LINK) $(LINKFLAGS) checkmaf.obj

mafcrd.obj :	mafcrd.for mafrec.inc
deview.obj :	deview.for
	- $(FORT) $(FFLAGS) deview.for

clean :
        - Delete /NoConfirm /NoLog *.obj;*
