	SUBROUTINE IMAGEIN(IMFILE)
!
!  opens the input image file; for each scan line unpacks pixels
!  and saves corrections as real pixel units in SCANS block;
!  puts header record and first scan line record into MAFREC block
!
!			name	type	description
!
!  input argument:	IMFILE	CHAR	fully qualified image file name,
!					  up to 128 characters in length
!
!
        COMMON /SCANS/  LNCOR,MLCS,NPIXL,SCANPIX
	COMMON /MAFREC/	HEADER,SCAN
!
	INTEGER*2	LCENTR(3),MLCS(121),NPIXL(121),DMLC,LMLC,
     &			LINECOUNT,ISINK,K,L,SCOFFSET,LBYTES,DCU,
     &			NADCOR(3),ORDERNC,IMSYNCVERS
	INTEGER*4	MAXPIXINLINE
	BYTE		SCANPIX(150,121),HEADER(404),SCAN(174),
     &			MLC,PIXEL(150)
	REAL*4		LNCOR(2,121)
	CHARACTER*128	IMFILE
!
	DATA	LCENTR/80,73,90/
!
	EQUIVALENCE	(HEADER(57),MAXPIXINLINE),
     &			(HEADER(389),IMSYNCVERS),(HEADER(395),SCOFFSET)
	EQUIVALENCE	(SCAN(3),LBYTES),(SCAN(9),MLC),(SCAN(13),DCU),
     &                  (SCAN(17),NADCOR(1)),(SCAN(23),ORDERNC),
     &			(SCAN(25),PIXEL(1))
!
!---set to continue on short scan line records
!	CALL ERRSET(67,.TRUE.,.FALSE.,.TRUE.,.FALSE.,122)
!
!---open file and read header record
	OPEN(UNIT=2,FILE=IMFILE,FORM='UNFORMATTED',TYPE='OLD',
     &	  READONLY)
	READ(2) HEADER
!
!---read each scan line record, get MLC, nadir corrections, and pixels
	LMLC = 0
	LINECOUNT = 0
 21	READ(2,END=40,ERR=25) (SCAN(K),K=1,MAXPIXINLINE+24)
 25	IF (LINECOUNT.EQ.0) THEN
	    LINECOUNT = 1
	ELSE
	    DMLC = ABS(ZEXT(MLC)-LMLC)
	    IF (DMLC.GT.1) THEN
		DO K=LINECOUNT+1,LINECOUNT+DMLC-1
		    NPIXL(K) = 0
		    MLCS(K) = -1
		    DO L=1,150
			SCANPIX(L,K) = -1
		    ENDDO
		ENDDO
	    ENDIF
	    LINECOUNT = LINECOUNT + DMLC
	ENDIF
	LMLC = ZEXT(MLC)
	MLCS(LINECOUNT) = LMLC
	LNCOR(1,LINECOUNT) = (NADCOR(1)+NADCOR(2)+NADCOR(3))/8.
     &				+ ISINK(IMSYNCVERS,DCU)
	IF (SCOFFSET.EQ.-75) THEN
	    LNCOR(2,LINECOUNT) = ORDERNC/100.
	ELSE
	    LNCOR(2,LINECOUNT) = 0.
	ENDIF
	NPIXL(LINECOUNT) = MIN(LBYTES-22,150)
	DO K=1,NPIXL(LINECOUNT)
	    SCANPIX(K,LINECOUNT) = PIXEL(K)
	ENDDO
	GO TO 21
!
 40	IF (LINECOUNT.LT.121) THEN
	    DO K=LINECOUNT+1,121
		MLCS(K) = -1
		NPIXL(K) = 0
	    ENDDO
	ENDIF
!
!---put first scan record back in SCAN and close file
	REWIND 2
	READ(2) HEADER
	READ(2,ERR=41) (SCAN(K),K=1,MAXPIXINLINE+24)
 41	CLOSE(UNIT=2)
!
	RETURN
!
	END
!
!
!
	INTEGER*2 FUNCTION ISINK(IMSYNC,DCU)
!
!  checks for the sinkhole problem, an artifact of an early software bug;
!  if the scan line is shifted down one pixel, sets function value to -1;
!  otherwise it is 0
!
!			name	type	description
!
!    input arguments:	IMSYNC	INT*2	IMSYNC version number from MAF
!					  header record
!			DCU	INT*2	DCU count from scan line record
!
!	      result:	ISINK	INT*2	-1 if scanline was moved down,
!					  0 if not
!
	INTEGER*2 IMSYNC,DCU
!
	ISINK = 0
	IF (IMSYNC.LT.195.AND.MOD(DCU,32).EQ.0) ISINK = -1
	RETURN
!
	END
