        Options /Extend_Source
	PROGRAM PIXCRD
!
!  uses CURRENT_IMAGE to prompt user for image file identification, sets
!  up the image file for coordinate calculations, then gets geographic
!  and GEI coordinates and luminosity for a sampling of pixels from
!  every tenth scan line in the image; output is to the user's terminal
!
!
        COMMON /IMAGE/  IMFILE,FCTDWN,FCTACR,NPHOT,CENTRMLC,PIXOFF
        COMMON /IMCOORD/IMXMIN,IMXMAX,IMYMAX,STEP,PIXWD,PIXHT,
     &                  SP,ALTF,NSPIN,TSPIN,UTNC1,SOLMSEC1,MDIREC
        COMMON /SCANS/  LNCOR,MLCS,NPIXL,SCANPIX
!
	BYTE		SCANPIX(150,121)
	CHARACTER*128	IMFILE
	INTEGER*2	MDIREC,L,P,ICOUNT,MLCS(121),NPIXL(121),NPHOT,
     &			CENTRMLC,PIXOFF
	INTEGER*4	UTNC1,NSPIN,TSPIN,SOLMSEC1,UT,UTPIX
	REAL*4		IMXMIN,IMXMAX,IMYMAX,STEP,PIXWD,PIXHT,SP,ALTF,
     &			GLAT,GLONG,XS,YS,XGEI,YGEI,ZGEI,RA,THETA,R,INTNS,
     &			LNCOR(2,121),GLT,FCTDWN,FCTACR
	LOGICAL*1	DSP,GOOD
!
!---get image file and set up for coordinate calculations and pixel
!			value retrieval
	DSP = .FALSE.				!image is not to be displayed
	CALL CURRENT_IMAGE(DSP)			!gets file ID
	CALL IMAGEIN(IMFILE)			!sets up for pixel retrieval
	CALL SETCRD				!sets up for coordinates
!
!---in every tenth scan line,
!		 get coordinates and intensity for every 25th pixel
	DO L=1,121,10				!try every 10th scan line
	  IF (NPIXL(L).GT.0) THEN		!are there pixels in that line?
	    WRITE(6,'(/,A,5X,A,12X,A,19X,A)')   !write output header
     &	      ' MLC PX#  UTPIX','KR','GEI', 'GEO         RA,DC'
	    DO P=1,NPIXL(L),25			!choose every 25th pixel
	      CALL LOCPX(MLCS(L),P,XS,YS)	!get view coordinates
	      INTNS = ICOUNT(			!convert count to luminosity
     &			ZEXT(SCANPIX(P,L)) )/SP
	      UT = UTPIX(XS,YS)			!get pixel UT
	      CALL VW2GEO(XS,YS,ALTF,		!get geographic coordinates
     &			GLAT,GLONG,GLT,GOOD)
	      CALL VW2GEI(XS,YS,ALTF,		!get GEI coordinates
     &	 		XGEI,YGEI,ZGEI,GOOD)
	      IF (GOOD) THEN			!if point is on Earth
		WRITE(6,'(I4,I4,I9,F6.1,A,2(F8.1,A),F8.1,A,2(F5.1,A))')	!    report results
     &		  MLCS(L),P,UT,INTNS,'(',XGEI, ',',YGEI,',',ZGEI,')',GLAT, 'N,',GLONG,'E'
	      ELSE				!if not on Earth
		CALL VWDRGEI(XS,YS,		!get right ascension and
     &				XGEI,YGEI,ZGEI)	!    declination
		CALL RECSPHD(XGEI,YGEI,
     &				ZGEI,R,THETA,RA)
		WRITE(6,'(I4,I4,I9,F6.1,42X,F5.1,A,F5.1)') !report results
     &		  MLCS(L),P,UT,INTNS,RA,',',90.-THETA
	      ENDIF
	    ENDDO
	  ENDIF
	ENDDO
!
	END
