	SUBROUTINE SETPLT (OutFile)
!
!  opens the GPLOT.DAT file if it exists and reads the previously saved
!  displayed pixel values into the SCREEN buffer, which is an array sized 
!  to resemble a display device. Otherwise, it creates a sets up for a
!  GIF file.
!
	COMMON /DISPLAY/ SCREEN,CX,CY
!
	INTEGER*2	SCREEN(0:767,0:1023),CX,CY,K,I
	LOGICAL		EXIST
        Character*64    OutFile
!
!---does display file exist?
	INQUIRE(FILE='GPLOT.DAT',EXIST=EXIST)
!---if so, open and read records into SCREEN columns
	IF (EXIST) THEN
	    OPEN(UNIT=3,FILE='GPLOT.DAT',FORM='UNFORMATTED',
     &			RECORDTYPE='FIXED',RECL=384,TYPE='OLD')
	    DO K=0,1023
		READ(3) (SCREEN(I,K),I=0,767)
	    ENDDO
	    REWIND 3
!---otherwise, open new file
	ELSE
            Write (6, '(A)') '$Enter output filename ==> '
            Read (5, '(A)') OutFile
!	    OPEN(UNIT=3,FILE='GPLOT.DAT',FORM='UNFORMATTED',
!     &			RECORDTYPE='FIXED',RECL=384,TYPE='NEW')
	ENDIF
!
	RETURN
	END
!
!
!
	SUBROUTINE DSPLIN(LINEX,LINEY,LINEOUT,ITOTAL)
!
!  fills in one vertical line of pixels in an array sized to resemble a
!  display device
!
!			name	type	description
!
!    input arguments:	LINEX	INT*2	horizontal screen position
!					  for top of line
!			LINEY	INT*2	vertical screen position for
!					  top of line
!			LINEOUT	INT*2	array of values to be displayed
!			ITOTAL	INT*2	number of elements in LINEOUT
!
	COMMON /DISPLAY/ SCREEN,CX,CY
!
	INTEGER*2	SCREEN(0:767,0:1023),CX,CY,LINEX,LINEY,
     &			LINEOUT(768),I,ITOTAL
!
	DO I=1,ITOTAL
	    SCREEN(LINEY-1+I,LINEX) = LINEOUT(I)
	ENDDO
!
	RETURN
	END
!
!
!
	SUBROUTINE DRAW(IX,IY)
!
!  draws a line of 255s from the last pen position to the given point
!  in an array representing a graphics display and set the current pen
!  position to the given point; the entry point MOVE only sets the current
!  pen position to the given point
!
!			name	type	description
!
!    input arguments:	IX	INT*2	new horizontal screen position
!			IY	INT*2	new vertical screen position
!
!
	COMMON /DISPLAY/ SCREEN,CX,CY
!
	INTEGER*2	SCREEN(0:767,0:1023),CX,CY,IX,IY,K,II,I,J
	REAL*4		M
!
	IF (IX.EQ.CX) THEN
	    DO K=CY,IY,ISIGN(1,IY-CY)
		SCREEN(MOD(K,768),IX) = 255
	    ENDDO
	ELSE
	    M = FLOAT(IY-CY)/FLOAT(IX-CX)
	    DO K=CX,IX,ISIGN(1,IX-CX)
		II = I
		I = NINT(M*(K-CX)) + CY
		IF (IABS(I-II).GT.1.AND.K.NE.CX) THEN
		    DO J=II,I,ISIGN(1,I-II)
			SCREEN(MOD(J,768),MOD(K,1024)) = 255
		    ENDDO
		ENDIF
		SCREEN(MOD(I,768),MOD(K,1024)) = 255
	    ENDDO
	ENDIF
!
	ENTRY MOVE(IX,IY)
!
	CX = MOD(IX,1024)
	CY = MOD(IY,768)
!
	RETURN
	END
!
!
!
	SUBROUTINE WRAPUP (OutFile)
!
!  writes the current contents of the SCREEN buffer to the binary disk
!  file GPLOT.DAT
!
	COMMON /DISPLAY/ SCREEN,CX,CY
	COMMON /IWINDOW/ IXMIN,IXMAX,IYMIN,IYMAX
!
	INTEGER*2	SCREEN(0:767,0:1023),CX,CY,IXMIN,IXMAX,IYMIN,IYMAX,
     &			K,I,X1,X2, Xsize, Temp, width, height

	Character       OutFile*64

        Byte            BitMap (0:1023, 0:767), ColorBar (0:2, 0:255), Byte

        Equivalence     (Byte, Temp)

!---create output GIF file
        Call RLD_VLT (ColorBar)
        Do i = 0, 1023
            Do k = 0, 767
                Temp = Screen (k, i)
                BitMap (i, k) = Byte
            EndDo
        EndDo
        Xsize = 1024
        width = iXmax - iXmin + 1
        height = iYmax - iYmin + 1
        Call EnGIF (OutFile, BitMap, Xsize, height, width, ColorBar, 8)

!
!---write each column into a record in 'GPLOT.DAT'
!	DO K=0,1023
!	    WRITE(3) (SCREEN(I,K),I=0,767)
!	ENDDO
!	CLOSE(UNIT=3)
!
	RETURN
	END
